#!/bin/bash
# 
# Copyright (c)  2021 Kevin HUART pour DynFi
# Permission is granted to copy, distribute and/or modify this document
# under the terms of the GNU GPL v.3 
# https://www.gnu.org/licenses/gpl-3.0.fr.html

format_date(){
	hour=$(($1 / 3600))
	min=$((($1 - $hour * 3600) / 60))
	sec=$(($1 - $hour * 3600 - $min * 60))

	echo "$hour heure(s), $min minute(s) et $sec seconde(s)."
}

format_taille(){
	if [[ $1 -ge 1000000000 ]]; then
		res=$(bc <<< $(echo "scale=2;$1/1000000000") | tr '.' ',')
		echo -n $res "To"
	elif [[ $1 -ge 1000000 ]]; then
		res=$(bc <<< $(echo "scale=2;$1/1000000") | tr '.' ',')
		echo -n $res "Go"
	elif [[ $1 -ge 1000 ]]; then
		res=$(bc <<< $(echo "scale=2;$1/1000") | tr '.' ',')
		echo -n $res "Mo"
	else
		echo -n $1 "Ko"
	fi
	echo $2
}

create_dir(){
	listDir="0..$(($1-1))"
	mkarg="mkdir -p ."
	for (( i = 0; i < $2; i++ )); do
		mkarg+="/{$listDir}"
	done
	eval $mkarg
}

back_to_root(){
	for (( u = 0; u < $1; u++ )); do
		cd ..
	done
}


if [[ $# == 9 || $# == 10 ]]; then
	
	output_bar=1
	
	while getopts "s" args; do
		case $args in
			s) output_bar=0;;
		esac
	done

	shift "$(($OPTIND - 1))"
	
	mkdir -p ${7}
	cd ${7}

	create_dir $9 $8

	tailleTotal=$((0))

	list_dir=($(find . -mindepth $8 -maxdepth $8 | tr " " "\n"))

	nextDos=1
	nbDos=$(($9**$8))
	nbFParDos=$(($1 / $((nbDos - 2))))
	numF=0

	nbfPrems=$((${1} * ${2} / 100))

	cd ${list_dir[0]}

	echo "--- Début du premier lot ---"
	if [[ ${4} > ${3} ]]; then
		taillemax=$((${4} - ${3}))
	else
		taillemax=${4}
	fi
	for (( i = 0; i < $nbfPrems; i++)); do
		if [[ $output_bar == 1 ]]; then
			echo -ne '\r['
		fi
		d=$(((($i+1) * 50) / $nbfPrems))

		if [[ $numF -ge $nbFParDos ]]; then
			if [[ "${list_dir[$nextDos]}" == "" ]]; then
				nextDos=0
			fi
			back_to_root $8
			cd ${list_dir[$nextDos]}
			nextDos=$((nextDos + 1))
			numF=0
		fi
		if [[ $output_bar == 1 ]]; then
			for (( j = 0; j < $d; j++ )); do
				echo -ne '~'
			done
			
			for (( j = $d; j < 50; j++ )); do
				echo -ne ' '
			done
			echo -ne '] '
			echo -ne $(((($i+1) * 100) / $nbfPrems))
			echo -ne '% ('
			echo -ne $((i+1))
			echo -ne '/'
			echo -ne $nbfPrems
			echo -ne ') '
		fi
		taille_init=$((${3} + $RANDOM % $taillemax))
		tailleTotal=$((tailleTotal + taille_init))
		taille=$(($taille_init * 2**10 * 3/4))
		nom=$(openssl rand -hex 16)
		openssl rand -out $nom.txt -base64 $taille
		numF=$((numF + 1))
	done
	if [[ $output_bar == 1 ]]; then
		echo -ne "\nTemps passé : "
	else
		echo -ne "$nbfPrems fichiers écrits en "
	fi
	first_time=$SECONDS
	format_date $first_time

	nbfDeux=$((${1} - $nbfPrems))
	echo ""
	echo "--- Début du deuxième lot ---"
	
	if [[ ${6} > ${5} ]]; then
		taillemax=$((${6} - ${5}))
	else
		taillemax=${6}
	fi
	for (( i = 0; i < $nbfDeux; i++)); do
		if [[ $output_bar == 1 ]]; then
			echo -ne '\r['
		fi
		d=$(((($i+1) * 50) / $nbfDeux))

		if [[ $numF -ge $nbFParDos ]]; then
			if [[ "${list_dir[$nextDos]}" == "" ]]; then
				nextDos=0
			fi
			back_to_root $8
			cd ${list_dir[$nextDos]}
			nextDos=$((nextDos + 1))
			numF=0
		fi

		if [[ $output_bar == 1 ]]; then
			for (( j = 0; j < $d; j++ )); do
				echo -ne '~'
			done
			for (( j = $d; j < 50; j++ )); do
				echo -ne ' '
			done
			echo -ne '] '
			echo -ne $(((($i+1) * 100) / $nbfDeux))
			echo -ne '% ('
			echo -ne $((i+1))
			echo -ne '/'
			echo -ne $nbfDeux
			echo -ne ')'
		fi

		taille_init=$((${5} + $RANDOM % $taillemax))
		tailleTotal=$((tailleTotal + taille_init))
		taille=$(($taille_init * 2**10 * 3/4))
		nom=$(openssl rand -hex 16)
		openssl rand -out $nom.txt -base64 $taille
		numF=$((numF + 1))
	done
	if [[ $output_bar == 1 ]]; then
		echo -ne "\nTemps passé : "
	else
		echo -ne "$nbfDeux fichiers écrits en "
	fi
	format_date $(($SECONDS - $first_time))
	echo ""
	echo "+--------| Statistiques globales |--------+"
	echo -ne "| Temps total : \t\t"
	format_date $SECONDS
	echo -e "| Nombre total de fichiers : \t$1"
	echo -ne "| Taille totale : \t\t"
	format_taille $tailleTotal
	echo -ne "| Vitesse moyenne d'écriture : \t"
	format_taille $((tailleTotal / $SECONDS)) "/sec"
	echo "|__________________________________________"



else
	echo ""
	echo "	+---| multi_gen_alea |---+"
	echo "	|                        |"
	echo "	|  Ce script permet de   |"
	echo "	|  générer des fichiers  |"
	echo "	|   de façon aléatoire   |"
	echo "	|                        |"
	echo "	|________KH@DynFi________|"
	echo ""
	echo "=== Mode d'utilisation guidée ==="
	echo ""
	echo "NB: Afin d'outrepasser le Mode d'utilisation guidée, veuillez utiliser ce programme de cette façon :"
	echo "bash multi_gen_alea.sh [-s] nbFichierTotal ratio(0<x<100) tailleMinPremier tailleMaxPremier tailleMinDeuxième tailleMaxDeuxième chemin nbCouchesArbo nbDosParCouches"
	echo "Les tailles sont en Ko."
	echo ""

	echo "Veuillez renseigner les informations suivantes :"
	read -p "	Nombre total de fichiers à créer:                   " nbf
	read -p "	Pourcentage de fichiers appartenant au premier lot: " perc
	read -p "	Taille minimale des fichiers du premier lot:        " minp
	read -p "	Taille maximale des fichiers du premier lot:        " maxp
	read -p "	Taille minimale des fichiers du deuxième lot:       " mind
	read -p "	Taille maximale des fichiers du deuxième lot:       " maxd
	read -p "	Chemin où les fichiers seront créés:                " chem
	read -p "	Nombre de couches d'arborescences:                  " nbCouches
	read -p "	Nombre de dossiers par couches:                     " nbDosParCouches
	read -p "	Montrer la bare de progression ? (o/n):             " bar
	echo ""
	echo "=== Lancement de la création des fichiers ===" 
	echo ""
	if [[ $bar == "n" ]]; then
		bash multi_gen_alea.sh -s $nbf $perc $minp $maxp $mind $maxd $chem $nbCouches $nbDosParCouches
	else
		bash multi_gen_alea.sh $nbf $perc $minp $maxp $mind $maxd $chem $nbCouches $nbDosParCouches
	fi
fi
